Filling PDF forms in TypeScript PDF Viewer

16 Feb 20265 minutes to read

The Syncfusion PDF Viewer supports filling form fields programmatically, via the user interface, or by importing form data from external sources.

  1. Filling form fields programmatically

Use the updateFormFieldsValue API to set or update field values dynamically based on application logic.

  1. Form Filling Through User Interface

Users can enter or select values directly in the PDF Viewer using supported form elements.

  1. Importing Form Field Data

Import form data to prefill fields from a JSON/FDF/XFDF source so forms are ready for review or signing.

Fill PDF forms programmatically

You can update the values of PDF form fields programmatically using the updateFormFieldsValue API. This method allows you to set or modify form field values dynamically based on application logic, without user interaction.

The following example demonstrates how to update PDF form field values programmatically:

<button id="updateBtn">Fill Form Fields</button>
// Wire up the button click
document.getElementById('updateBtn')!.onclick = () => {
  //Retriveformfields
  const fields =
    pdfviewer.retrieveFormFields?.() || pdfviewer.formFieldCollection || [];
  //Get form fields by name
  const field = fields.find((f) => f?.name === 'name') || fields[0];

 //Update the Values
  if (field) {
    field.value = 'John Doe';
    field.tooltip = 'First';
    pdfviewer.updateFormFieldsValue(field);
  } else {
    console.warn('No form fields available to update.');
  }
};

Fill PDF forms through the user interface

The Syncfusion PDF Viewer lets users fill form fields directly in the viewer. Clicking a field allows users to enter text, select options, or sign where supported.

Fill text and signature fields in PDF Viewer

The PDF Viewer supports text boxes, check boxes, radio buttons, drop-down lists, list boxes, and signature fields. Filled values remain editable during the viewing session.

Fill PDF forms through Import Data

The Syncfusion PDF Viewer allows you to import form field data into an existing PDF document using the importFormFields API. This feature enables you to pre-fill form fields using data from an external source without requiring manual user input.

Imported form field data is automatically mapped to the corresponding form fields in the PDF document based on the field names. Once the data is imported, the populated values are displayed in the PDF Viewer and can be edited through the user interface if required.

<button id="importJson">Import JSON</button>
document.getElementById('importJson')!.addEventListener('click', () => {
  // The file for importing should be accessible at the given path or as a file stream depending on your integration
  viewer.importFormFields('File', FormFieldDataFormat.Json);
});

For more details, see Import Form Data.

How to get the filled data and store it to a backing system

You can export the filled form field data from the PDF Viewer and store it in a backing system such as a database or file storage. The exported data can later be imported to restore the form state.

For more details, see Export Form Data.

How to Validate Form Fields using validateFormFields Event

The validateFormFields event in the Syncfusion PDF Viewer is triggered when a user tries to download or submit a form while validation is enabled. You can use the retrieveFormFields() API to get all the form fields and check them one by one to see if any form fields values are empty.

This validation applies to all form field types in the PDF Viewer. A textbox is empty if no text is entered, a list box or dropdown is empty if no item is selected, a signature or initial field is empty if the user has not signed, and radio buttons or checkboxes are empty if none are chosen.
By enabling enableFormFieldsValidation and wiring the event, you can go through each field and stop the action if required fields are not filled.

pdfviewer.enableFormFieldsValidation = true;
 
pdfviewer.documentLoad = () => {
  // Add a required Email field
  pdfviewer.formDesignerModule.addFormField('Textbox', {
    name: 'Email',
    bounds: { X: 146, Y: 260, Width: 220, Height: 24 },
    isRequired: true,
    tooltip: 'Email is required',
  } as TextFieldSettings);
 
  // Add a required Phone field
  pdfviewer.formDesignerModule.addFormField('Textbox', {
    name: 'Phone',
    bounds: { X: 146, Y: 300, Width: 220, Height: 24 },
    isRequired: true,
    tooltip: 'Phone number is required',
  } as TextFieldSettings);
};
 
// Validate only the added fields
pdfviewer.validateFormFields = (args: any) => {
  const fields = pdfviewer.retrieveFormFields();
 
  fields.forEach((field) => {
    if ((field.name === 'Email' || field.name === 'Phone') && !field.value) {
      alert(field.name + ' field cannot be empty.');
      args.isFormSubmitCancelled = true;
    }
  });
};

See also

Filling PDF Forms in Vue PDF Viewer

24 Jun 202610 minutes to read

The PDF Viewer supports three form-filling approaches:

  1. Filling Form Fields Programmatically

    Form fields can be filled or updated programmatically using the updateFormFieldsValue API. This approach is useful when form data must be set dynamically by application logic.

  2. Form Filling Through User Interface

    End users can fill PDF form fields directly through the PDF Viewer interface by typing text, selecting options, or interacting with supported form elements.

  3. Importing Form Field Data

    The PDF Viewer can import form field data into an existing PDF document to pre-fill fields from external data sources.

Fill PDF forms programmatically

Form field values can be updated programmatically using the updateFormFieldsValue API. This method allows applications to set or modify form field values dynamically without end-user interaction.

The following example demonstrates how to update PDF form field values programmatically:

<template>
  <div>
    <button @click="fillForm">Fill Form Fields</button>
    <ejs-pdfviewer id="pdfViewer" ref="pdfviewer" :documentPath="documentPath" :resourceUrl="resourceUrl" style="height:640px" />
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer,
} from '@syncfusion/ej2-vue-pdfviewer';


export default {
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib',
    };
  },
  provide: {
    PdfViewer: [Toolbar, Magnification, Navigation, Annotation, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer],
  },
  methods: {
    fillForm() {
      const pdfviewer = this.$refs.pdfviewer.ej2Instances;
      const fields = pdfviewer.retrieveFormFields?.() || pdfviewer.formFieldCollection || [];
      const field = fields.find((f) => f?.name === 'name') || fields[0];
      if (field) {
        field.value = 'John Doe';
        field.tooltip = 'First';
        pdfviewer.updateFormFieldsValue(field);
      } else {
        console.warn('No form fields available to update.');
      }
    },
  },
};
</script>

Fill PDF forms through the User Interface

The PDF Viewer enables end users to complete form fields directly in the interface without code. Fields accept input appropriate to their type.

Form Filling

The PDF Viewer supports common form fields such as text boxes, check boxes, radio buttons, drop-down lists, list boxes, and signature fields. Entered values remain editable during the viewing session.

Fill PDF forms through Import Data

The PDF Viewer can import form field data into an existing PDF document using the importFormFields API. This enables pre-filling fields from external data sources without manual entry.

Imported data is mapped to PDF form fields by field name. The imported values appear in the viewer and remain editable if the document permits modification. Refer to Import Form Data for details about expected data formats and mapping rules.

<template>
  <div>
    <button @click="importJson">Import JSON</button>
    <ejs-pdfviewer id="pdfViewer" ref="pdfviewer" :documentPath="documentPath" :resourceUrl="resourceUrl" style="height:640px" />
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer,
  FormFieldDataFormat
} from '@syncfusion/ej2-vue-pdfviewer';


export default {
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib',
    };
  },
  provide: {
    PdfViewer: [Toolbar, Magnification, Navigation, Annotation, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer],
  },
  methods: {
    importJson() {
      const pdfviewer = this.$refs.pdfviewer.ej2Instances;
      // The file for importing should be accessible at the given path or as a file stream depending on your integration
      pdfviewer.importFormFields('File', FormFieldDataFormat.Json);
    },
  },
};
</script>

For more details, see Import Form Data.

How to get the filled data and store it to a backing system

Filled form field data can be exported from the PDF Viewer and stored in a backing system such as a database or file storage. Exported data can be re-imported later to restore form state. See Export Form Data for supported export formats and recommended persistence patterns.

For more details, see Export Form Data.

How to Validate Form Fields using validateFormFields Event

The validateFormFields event fires when a download or submit action is attempted while validation is enabled. The retrieveFormFields() API returns all form fields so the application can validate values before proceeding.

Validation applies to all field types: a textbox is considered empty if it contains no text; a list box or dropdown is empty when no item is selected; a signature or initial field is empty if no signature exists; and radio buttons or checkboxes are empty when none are chosen.

Enable enableFormFieldsValidation and handle the event to cancel submit/download actions when required fields are missing.

<template>
  <div>
    <ejs-pdfviewer id="pdfViewer" ref="pdfviewer" :documentPath="documentPath" :resourceUrl="resourceUrl" style="height:640px" @documentLoad="onDocumentLoad" />
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer,
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib',
    };
  },
  provide: {
    PdfViewer: [Toolbar, Magnification, Navigation, Annotation, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer],
  },
  methods: {
    onDocumentLoad() {
      const pdfviewer = this.$refs.pdfviewer.ej2Instances;
      pdfviewer.enableFormFieldsValidation = true;

      // Add required fields
      pdfviewer.formDesignerModule.addFormField('Textbox', {
        name: 'Email',
        bounds: { X: 146, Y: 260, Width: 220, Height: 24 },
        isRequired: true,
        tooltip: 'Email is required',
      });

      pdfviewer.formDesignerModule.addFormField('Textbox', {
        name: 'Phone',
        bounds: { X: 146, Y: 300, Width: 220, Height: 24 },
        isRequired: true,
        tooltip: 'Phone number is required',
      });

      // Validate only the added fields
      pdfviewer.validateFormFields = (args) => {
        const fields = pdfviewer.retrieveFormFields();
        fields.forEach((field) => {
          if ((field.name === 'Email' || field.name === 'Phone') && !field.value) {
            alert(field.name + ' field cannot be empty.');
            args.isFormSubmitCancelled = true;
          }
        });
      };
    },
  },
};
</script>

See also

Fill PDF form fields in Angular PDF Viewer

7 Apr 20269 minutes to read

This guide shows how to update, import, and validate PDF form fields in the Angular PDF Viewer so you can pre-fill forms or accept user input.

Outcome Programmatically set field values, allow UI-driven filling, import form data, and validate fields on submit.

Steps to fill forms

1. Fill form fields programmatically

Update form field values programmatically with updateFormFieldsValue.

Use the example below as a complete, runnable example for your Angular app. It retrieves form fields and updates a named field or the first available field.

import { Component, OnInit, ViewChild } from '@angular/core';
import {
  ToolbarService,
  MagnificationService,
  NavigationService,
  AnnotationService,
  TextSelectionService,
  TextSearchService,
  FormFieldsService,
  FormDesignerService,
  PdfViewerComponent,
  PdfViewerModule,
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [PdfViewerModule],
  template: `
    <div class="content-wrapper">
      <button (click)="fillForm()">Fill Form Fields</button>
      <ejs-pdfviewer
        #pdfViewer
        id="pdfViewer"
        [resourceUrl]="resourceUrl"
        [documentPath]="document"
        style="height: 640px; display: block;">
      </ejs-pdfviewer>
    </div>
  `,
  providers: [
    ToolbarService,
    MagnificationService,
    NavigationService,
    AnnotationService,
    TextSelectionService,
    TextSearchService,
    FormFieldsService,
    FormDesignerService,
  ],
})
export class AppComponent implements OnInit {
  @ViewChild('pdfViewer') pdfviewer!: PdfViewerComponent;
  public document: string = 'https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf';
  public resourceUrl: string = 'https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib';

  ngOnInit(): void {}

  fillForm(): void {
    const fields =
      this.pdfviewer?.retrieveFormFields?.() || (this.pdfviewer as any).formFieldCollection || [];
    const field = fields.find((f: any) => f?.name === 'name') || fields[0];

    if (field) {
      field.value = 'John Doe';
      field.tooltip = 'First';
      this.pdfviewer.updateFormFieldsValue(field);
    } else {
      console.warn('No form fields available to update.');
    }
  }
}

Expected result: Clicking the Fill Form Fields button sets the first or named field’s value to John Doe in the viewer.

2. Fill form fields via UI

Users can click form controls and enter/select values. Supported field types include textboxes, checkboxes, radio buttons, dropdowns, list boxes, and signature fields. Edits are retained during the viewing session.

Form Filling

3. Fill form fields through imported data

Use importFormFields to map external data into PDF fields by name. The example below shows how to trigger import from a button handler.

import { Component, OnInit, ViewChild } from '@angular/core';
import {
  ToolbarService,
  MagnificationService,
  NavigationService,
  AnnotationService,
  TextSelectionService,
  TextSearchService,
  FormFieldsService,
  FormDesignerService,
  PdfViewerComponent,
  PdfViewerModule,
} from '@syncfusion/ej2-angular-pdfviewer';
import { FormFieldDataFormat } from '@syncfusion/ej2-pdfviewer';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [PdfViewerModule],
  template: `
    <div class="content-wrapper">
      <button (click)="importJson()">Import JSON</button>
      <ejs-pdfviewer
        #pdfViewer
        id="pdfViewer"
        [resourceUrl]="resourceUrl"
        [documentPath]="document"
        style="height: 640px; display: block;">
      </ejs-pdfviewer>
    </div>
  `,
  providers: [
    ToolbarService,
    MagnificationService,
    NavigationService,
    AnnotationService,
    TextSelectionService,
    TextSearchService,
    FormFieldsService,
    FormDesignerService,
  ],
})
export class AppComponent implements OnInit {
  @ViewChild('pdfViewer') pdfviewer!: PdfViewerComponent;
  public document = 'https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf';
  public resourceUrl = 'https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib';

  ngOnInit(): void {}

  importJson(): void {
    // NOTE:
    // The first parameter can be:
    //  - a file path/url (in server mode),
    //  - or a base64 encoded File/Blob stream from an <input type="file"> in real apps.
    // Replace 'File' with your actual file or path as per your integration.
    this.pdfviewer.importFormFields('File', FormFieldDataFormat.Json);
  }
}

For more details, see Import Form Data.

4. Validate form fields on submit

Enable enableFormFieldsValidation and handle validateFormFields to check required fields and cancel submission when necessary. Example below shows adding required fields and validating them.

import { Component, OnInit, ViewChild } from '@angular/core';
import {
  ToolbarService,
  MagnificationService,
  NavigationService,
  AnnotationService,
  TextSelectionService,
  TextSearchService,
  FormFieldsService,
  FormDesignerService,
  PdfViewerComponent,
  PdfViewerModule,
} from '@syncfusion/ej2-angular-pdfviewer';
import { TextFieldSettings } from '@syncfusion/ej2-pdfviewer';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [PdfViewerModule],
  template: `
    <div class="content-wrapper">
      <ejs-pdfviewer
        #pdfViewer
        id="pdfViewer"
        [resourceUrl]="resourceUrl"
        [documentPath]="document"
        [enableFormFieldsValidation]="true"
        (documentLoad)="onDocumentLoad()"
        (validateFormFields)="onValidateFormFields($event)"
        style="height: 640px; display: block;">
      </ejs-pdfviewer>
    </div>
  `,
  providers: [
    ToolbarService,
    MagnificationService,
    NavigationService,
    AnnotationService,
    TextSelectionService,
    TextSearchService,
    FormFieldsService,
    FormDesignerService,
  ],
})
export class AppComponent implements OnInit {
  @ViewChild('pdfViewer') pdfviewer!: PdfViewerComponent;
  public document = 'https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf';
  public resourceUrl = 'https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib';

  ngOnInit(): void {}

  // Runs after the document is loaded into the viewer
  onDocumentLoad(): void {
    // Add a required Email field
    this.pdfviewer.formDesignerModule.addFormField('Textbox', {
      name: 'Email',
      bounds: { X: 146, Y: 260, Width: 220, Height: 24 },
      isRequired: true,
      tooltip: 'Email is required',
    } as TextFieldSettings);

    // Add a required Phone field
    this.pdfviewer.formDesignerModule.addFormField('Textbox', {
      name: 'Phone',
      bounds: { X: 146, Y: 300, Width: 220, Height: 24 },
      isRequired: true,
      tooltip: 'Phone number is required',
    } as TextFieldSettings);
  }

  // Validates the added fields on form submit/validate trigger
  onValidateFormFields(args: any): void {
    const fields = this.pdfviewer.retrieveFormFields();

    fields.forEach((field: any) => {
      if ((field.name === 'Email' || field.name === 'Phone') && !field.value) {
        alert(field.name + ' field cannot be empty.');
        args.isFormSubmitCancelled = true;
      }
    });
  }
}

Troubleshooting

  • If fields are not editable, confirm FormFields module is injected into PDF Viewer.
  • If examples fail to load, verify your resourceUrl matches the installed PDF Viewer version.
  • For import issues, ensure JSON keys match the PDF field name values.

See also

Fill PDF form fields in React PDF Viewer

21 Apr 202616 minutes to read

This guide shows how to update, import, and validate PDF form fields in the React PDF Viewer so you can pre-fill forms or accept user input.

Outcome Programmatically set field values, allow UI-driven filling, import form data, and validate fields on submit.

Steps to fill forms

1. Fill form fields programmatically

Update form field values programmatically with updateFormFieldsValue.

Use the example below as a complete, runnable example for a small React app. It retrieves form fields and updates a named field or the first available field.

import { RefObject, useRef } from 'react';
import {
    PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView,
    ThumbnailView, Print, TextSelection, TextSearch, Annotation, FormFields, Inject,
    FormDesigner, PageOrganizer
} from '@syncfusion/ej2-react-pdfviewer';

export default function App() {
    const viewerRef: RefObject<PdfViewerComponent> = useRef(null);

    const handleFillForm = () => {
        const viewer = viewerRef.current;
        if (!viewer) return;

        // Retrieve form fields from the viewer
        const fields =
            (viewer.retrieveFormFields && viewer.retrieveFormFields()) ||
            viewer.formFieldCollections ||
            [];
        // Find by name or fallback to the first field
        const field = fields.find((f) => f && f.name === 'name') || fields[0];

        if (field) {
            field.value = 'John Doe';
            field.tooltip = 'First';
            // Push changes to viewer
            viewer.updateFormFieldsValue(field);
        } else {
            console.warn('No form fields available to update.');
        }
    };

    return (
        <div>
            <div className="control-section" style={{ marginBottom: 12 }}>
                <button id="updateBtn" onClick={handleFillForm}>
                    Fill Form Fields
                </button>
            </div>

            <div className="control-section">
                <PdfViewerComponent
                    ref={viewerRef}
                    id="container"
                    // Use a PDF that contains form fields
                    documentPath="https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf"
                    resourceUrl="https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib"
                    style={{ height: '680px', width: '100%' }}
                >
                    <Inject
                        services={[
                            Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, BookmarkView, ThumbnailView, Print, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer ]}
                    />
                </PdfViewerComponent>
            </div>
        </div>
    );
}

Expected result: Clicking the Fill Form Fields button sets the first or named field’s value to John Doe in the viewer.

2. Fill form fields via UI

Users can click form controls and enter/select values. Supported field types include textboxes, checkboxes, radio buttons, dropdowns, list boxes, and signature fields. Edits are retained during the viewing session.

Form Filling

3. Fill form fields through imported data

Use importFormFields to map external data into PDF fields by name. The example below shows how to trigger import from a button handler.

import { RefObject, useRef } from 'react';
import {
    PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView,
    ThumbnailView, Print, TextSelection, TextSearch, Annotation, FormFields, Inject,
    FormDesigner, PageOrganizer, FormFieldDataFormat
} from '@syncfusion/ej2-react-pdfviewer';

export default function App() {
    const viewerRef: RefObject<PdfViewerComponent> = useRef(null);

    const handleImportJson = () => {
        const viewer = viewerRef.current;
        if (!viewer) return;
        // NOTE:
        // The first parameter can be:
        //  - a file path/url (in server mode),
        //  - or a base64 encoded File/Blob stream from an <input type="file"> in real apps.
        // Replace 'File' with your actual file or path as per your integration.
        viewer.importFormFields('File', FormFieldDataFormat.Json);
    };

    return (
        <div>
            <div className="control-section" style={{ marginBottom: 12 }}>
                <button id="importJson" onClick={handleImportJson}>
                    Import JSON
                </button>
            </div>

            <div className="control-section">
                <PdfViewerComponent
                    ref={viewerRef}
                    id="container"
                    // Use a PDF that contains form fields
                    documentPath="https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf"
                    resourceUrl="https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib"
                    style={{ height: '680px', width: '100%' }}
                >
                    <Inject
                        services={[
                            Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, BookmarkView, ThumbnailView, Print, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer]}
                    />
                </PdfViewerComponent>
            </div>
        </div>
    );
}

For more details, see Import Form Data.

4. Validate form fields on submit

Enable enableFormFieldsValidation and handle validateFormFields to check required fields and cancel submission when necessary. Example below shows adding required fields via formDesignerModule and validating them.

import { RefObject, useRef } from 'react';
import {
    PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation,
    ThumbnailView, BookmarkView, TextSelection, Annotation, FormDesigner, FormFields,
    Inject, TextFieldSettings
} from '@syncfusion/ej2-react-pdfviewer';

export default function App() {
    const viewerRef: RefObject<PdfViewerComponent> = useRef(null);

    // Runs after the document is loaded into the viewer
    const handleDocumentLoad = () => {
        const viewer = viewerRef.current;
        if (!viewer) return;

        // Add a required Email field
        viewer.formDesignerModule.addFormField('Textbox', {
            name: 'Email',
            bounds: { X: 146, Y: 260, Width: 220, Height: 24 },
            isRequired: true,
            tooltip: 'Email is required',
        } as TextFieldSettings);

        // Add a required Phone field
        viewer.formDesignerModule.addFormField('Textbox', {
            name: 'Phone',
            bounds: { X: 146, Y: 300, Width: 220, Height: 24 },
            isRequired: true,
            tooltip: 'Phone number is required',
        } as TextFieldSettings);
    };

    // Validates only the added fields on form submit/validate trigger
    const handleValidateFormFields = () => {
        const viewer = viewerRef.current;
        if (!viewer) return;

        const fields = viewer.retrieveFormFields ? viewer.retrieveFormFields() : [];

        fields.forEach((field) => {
            if ((field.name === 'Email' || field.name === 'Phone') && !field.value) {
                alert(field.name + ' field cannot be empty.');
            }
        });
    };

    return (
        <div className="control-section">
            <PdfViewerComponent
                ref={viewerRef}
                id="pdfViewer"
                documentPath="https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf"
                resourceUrl="https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib"
                // Enable built-in validation flow
                enableFormFieldsValidation={true}
                // Hook events
                documentLoad={handleDocumentLoad}
                validateFormFields={handleValidateFormFields}
                style={{ height: '680px', width: '100%' }}
            >
                <Inject
                    services={[
                        Toolbar, Magnification, Navigation, LinkAnnotation, ThumbnailView, BookmarkView,
                        TextSelection, Annotation, FormDesigner, FormFields
                    ]}
                />
            </PdfViewerComponent>
        </div>
    );
}

Troubleshooting

  • If fields are not editable, confirm FormFields module is injected into PDF Viewer.
  • If examples fail to load, verify your resourceUrl matches the installed PDF Viewer version.
  • For import issues, ensure JSON keys match the PDF field name values.

See also